. "$PSScriptRoot\common.ps1"

$ErrorActionPreference="SilentlyContinue"
Stop-Transcript | out-null
$ErrorActionPreference = "Continue"
Start-Transcript -path $updatelogPath -Append -Force

try {
	# This is done first as it might fail
	downloadNwjs

	# Stop the watchdogs as the file it points to is being replaced. This might take a few minutes though to happen
	Unregister-ScheduledTask -TaskName "$watchdogTaskName" -Confirm:$false
	Unregister-ScheduledTask -TaskName "$explorerWatchdogTaskName" -Confirm:$false

	$watchdogTask = Get-ScheduledTask -TaskName "$watchdogTaskName" -ErrorAction SilentlyContinue
	if ($watchdogTask) {
		Write-Output "Task $watchdogTaskName still exists after call to Unregister-ScheduledTask. This shouldn't happen."
		throw "Task $watchdogTaskName still exists after call to Unregister-ScheduledTask. This shouldn't happen."
	}

	$explorerWatchdogTask = Get-ScheduledTask -TaskName "$explorerWatchdogTaskName" -ErrorAction SilentlyContinue
	if ($explorerWatchdogTask) {
		Write-Output "Task $explorerWatchdogTaskName still exists after call to Unregister-ScheduledTask. This shouldn't happen."
		throw "Task $explorerWatchdogTaskName still exists after call to Unregister-ScheduledTask. This shouldn't happen."
	}

	# Try to wait for NWJS to end on its own. After a minute give up and try to kill it
	$killNwjs = $true
	for ($itr = 0; $itr -le 10; ++$itr) {
		Get-Process nw
		if ($?) {
			Start-Sleep -s 6
		} else {
			$killNwjs = $false
			break
		}
	}
	if ($killNwjs) {
		# Hope for the best
		Stop-Process -Name "nw" -ErrorAction SilentlyContinue
		Start-Sleep -s 1
	}

	$version = "00.00.00"
	$versionPath = FormatPath "$rootPath\breezeversion"
	if (Test-Path $versionPath) {
		$version = Get-Content $versionPath | Out-String
	}

	CopyFiles
	#installNode
	installNwjs
	CreateWatchdog
	CreateShortcuts
	OptimizingPowershell

	# Remove the update.lock file and re-launch breeze
	Remove-Item -Path $updateLockPath -Force

	Start-Process -WindowStyle Hidden PowerShell.exe -Args "-WindowStyle Hidden $watchdogPs1Path"
} catch {
	Write-Output $_

	# Remove the lock file even if the update failed...
	Remove-Item -Path $updateLockPath -Force
} finally {
	Stop-Transcript
}