#!/bin/bash
# If this script is run by the Breeze 2.x container, then the cwd will be set such that the update directories look like this:
# Before 3.00.28:
# - ..
# - breeze2nwjscontainer
# 	- container
# 		- package.json
#		- node_modules
#		- src
#	- scripts
# After 3.00.28:
#	- 03_00_27_50
#		- breeze2nwjscontainer
#			- scripts
#				- updater.sh
#	- boxcutter
#	- fonts
#	- icons
#	- images
#	- scripts
#	- breezeversion
# 	- package.json
#	- ...
updateDirectory=$(cd "$(dirname "${BASH_SOURCE[0]}")/.." && pwd)
. $updateDirectory/scripts/common.sh

# Try to wait for NWJS to end on its own
# After a minute give up and try to kill it
killNwjs=true
itr=0
while [ $itr -lt 10 ]; do
	if [ "\$(pidof nw)" ]; then
		sleep 6s
	else
		killNwjs=
		break
	fi
	itr=$((itr + 1))
done
if [[ "$killNwjs" = true ]]; then
	pkill nw
	sleep 1s
fi

# Preform logic that is specific to certain updates if applicable
version="00.00.00"
versionPath=$rootPath/breezeversion
if [ -e $versionPath ] ; then
	version="$(<$versionPath)"
fi
freshInstall=
if [[ $(CompareVersions $version "00.00.00") -eq 0 ]] ; then
	freshInstall=true
	echo "Assuming this is a fresh install.."
fi

CopyFiles
#InstallNode
InstallNwjs
CreateLogs
CreateWatchdog
CreateShortcuts

# Remove the update.lock file and re-launch breeze
rm $updateLockPath

nohup "$rootPath/watchdog.sh" 1>>$outlogPath 2>>$errlogPath &
